#include "player.hpp"
#include "assets.hpp"
#include "config.hpp"
#include "state.hpp"
#include "texture.hpp"
#include <stdexcept>

void PRenderPlayer(PPlayer *player) {
  PhoenixTexture *playerUpTexture = PGetTextureById(PLAYER_WALK_UP_TEXTURE_ID);
  PhoenixTexture *playerDownTexture =
      PGetTextureById(PLAYER_WALK_DOWN_TEXTURE_ID);
  PhoenixTexture *playerLeftTexture =
      PGetTextureById(PLAYER_WALK_LEFT_TEXTURE_ID);
  PhoenixTexture *playerRightTexture =
      PGetTextureById(PLAYER_WALK_RIGHT_TEXTURE_ID);

  if (player->facing == Up) {
    PRenderTexture(playerUpTexture, player->x, player->y);
  } else if (player->facing == Down) {
    PRenderTexture(playerDownTexture, player->x, player->y);
  } else if (player->facing == Left) {
    PRenderTexture(playerLeftTexture, player->x, player->y);
  } else if (player->facing == Right) {
    PRenderTexture(playerRightTexture, player->x, player->y);
  } else {
    throw std::runtime_error(
        "Invalid player->facing direction, expected Up, Down, Left, or Right");
  }
}

SDL_Rect PGetPlayerRect(PPlayer *player) {
  SDL_Rect rect{};
  rect.x = player->x;
  rect.y = player->y;
  rect.w = TEXTURE_WIDTH;
  rect.h = TEXTURE_HEIGHT;

  return rect;
}
